%{
#include <stdlib.h>
#include <string.h>
#include "p2p.h"
#include "p2p.tab.h"

extern int inputfile;
extern char **inputfiles;
extern int lineno;
int retws=0;
int rvcnt;

char * p2p_p2p_l = "$Id: p2p.l,v 1.11 2000/06/25 10:55:18 fp Exp $";
%}

%s PRE
%s PARAM
%s EXT
%s EXT2
%s COMM
%s LDFO
%s LDFP
%s RVRI
%s RVRP
%s RVRN
%s XPO
%s XPD

%%
<PARAM>[+-]?[0-9]+(\.[0-9]*)?([eE][+-]?[0-9]+)? {
  yylval.v_number = strtod (yytext, NULL);
  return NUMBER;
}
<PARAM>[+-]?[0-9]*\.[0-9]*([eE][+-]?[0-9]+)? {
  yylval.v_number = strtod (yytext, NULL);
  return NUMBER;
}
<LDFO,RVRN,XPO>[+-]?[0-9]+ {
  yylval.v_integer = (int) strtol (yytext, NULL, 10);
  return INTEGER;
}
<INITIAL>!R!	{ yylval.v_keyword = PRESCRIBE; BEGIN(PRE); return PRESCRIBE; }
<INITIAL>[^!\n\f\r]+ { strcpy (yylval.v_string, yytext); return PLAINTEXT; }
<INITIAL>\r?\n	{ lineno++; return '\n'; }
<INITIAL>\f	{ lineno++; return '\f'; }

<PRE>EXIT	{ yylval.v_keyword = EXIT; BEGIN(EXT); return EXIT; }
<EXT>[ ]+	{ if (retws) return WS; }
<EXT>;		{ BEGIN(INITIAL); return yytext[0]; }
<EXT>,		return yytext[0];
<EXT>E[ ]*	{ BEGIN(EXT2); return yytext[0]; }
<EXT2>;(\r?\n)?	{ BEGIN(INITIAL); if (yytext[0]=='\n') lineno++; return ';'; }

<PRE>CMNT	{ yylval.v_keyword = CMNT; BEGIN(COMM); return CMNT; }
<COMM>[^;\n\r]+	{ strcpy (yylval.v_string, yytext); return COMMENT; }
<COMM>\r?\n	lineno++;
<COMM>;		{ BEGIN(PRE); return yytext[0]; }

<PRE>LDFC	{ yylval.v_keyword = LDFC; BEGIN(LDFO); return LDFC; }
<LDFO>[ \t]+	{ if (retws) return WS; }
<LDFO>,		return yytext[0];
<LDFO>;		{ BEGIN(LDFP); return yytext[0]; }
<LDFP>;		{ BEGIN(PRE); return yytext[0]; }

<PRE>RVRD;	{ BEGIN(RVRI); yylval.v_keyword = RVRD; return RVRD; }
<RVRI>[0-9]+  {
  rvcnt = yylval.v_integer = (int) strtol (yytext, NULL, 10);
  return INTEGER;
}
<RVRI>;		{ BEGIN(RVRP); return yytext[0]; }
<RVRI>,		{ BEGIN(RVRN); return yytext[0]; }
<RVRI>ENDR	{ BEGIN(PRE); yylval.v_keyword = ENDR; return ENDR; }
<RVRN>,		return yytext[0];
<RVRN>;		{ BEGIN(RVRI); return yytext[0]; }
<LDFP,RVRP,XPD>[/@-~\x7f][/@-~\x7f][0-?] {
  rvcnt -= 2; strcpy (yylval.v_string, yytext); return OPTIONS;
}
<LDFP,RVRP,XPD>[/@-~\x7f][/@-~\x7f]\r?[ \n][0-?] {
  strcpy (yylval.v_string, yytext);
  if (yylval.v_string[2] == '\r') yylval.v_string[2]=yylval.v_string[4];
  else                            yylval.v_string[2]=yylval.v_string[3];
  yylval.v_string[3] = '\0';
  lineno++;
  rvcnt -= 2;
  return OPTIONS;
}
<LDFP,RVRP,XPD>[/@-~\x7f]\r?[ \n][/@-~\x7f][0-?] { 
  strcpy (yylval.v_string, yytext);
  if (yylval.v_string[1] == '\r') {
    yylval.v_string[1]=yylval.v_string[3];
    yylval.v_string[2]=yylval.v_string[4];
  }
  else {
    yylval.v_string[1]=yylval.v_string[2];
    yylval.v_string[2]=yylval.v_string[3];
  }
  yylval.v_string[3] = '\0';
  lineno++;
  rvcnt -= 2;
  return OPTIONS;
}
<RVRP,XPD>[/@-~\x7f][0-?] {
  yylval.v_string[0] = '@';
  strcpy (yylval.v_string+1, yytext);
  rvcnt -= 2;
  return OPTIONS;
}
<RVRP,XPD>[/@-~\x7f]\r?[ \n][0-?] {
  yylval.v_string[0] = '@';
  strcpy (yylval.v_string+1, yytext);
  if (yylval.v_string[2] == '\r') yylval.v_string[2]=yylval.v_string[4];
  else                            yylval.v_string[2]=yylval.v_string[3];
  yylval.v_string[3] = '\0';
  lineno++;
  rvcnt -= 2;
  return OPTIONS;
}
<RVRP>[0-?] {
  if (!rvcnt && yytext[0] == ';') {
    BEGIN(RVRI);
    return yytext[0];
  }
  yylval.v_string[0] = '@';
  yylval.v_string[1] = '@';
  yylval.v_string[2] = yytext[0];
  yylval.v_string[3] = '\0';
  rvcnt -= 2;
  return OPTIONS;
}

<PRE>XPAT	{
  BEGIN(XPO);
  rvcnt = 32;
  yylval.v_keyword = XPAT;
  return XPAT;
}
<XPO>;		{ BEGIN(XPD); return yytext[0]; }
<XPD>[0-?] {
  if (!rvcnt && yytext[0] == ';') {
    BEGIN(PRE);
    return yytext[0];
  }
  yylval.v_string[0] = '@';
  yylval.v_string[1] = '@';
  yylval.v_string[2] = yytext[0];
  yylval.v_string[3] = '\0';
  rvcnt -= 2;
  return OPTIONS;
}

<PRE>MCRO	{ yylval.v_keyword = MCRO; BEGIN(PARAM); return MCRO; }
<PRE>ENDM	{ yylval.v_keyword = ENDM; BEGIN(PARAM); return ENDM; }
<PRE>SCRC	{ yylval.v_keyword = SCRC; BEGIN(PARAM); return SCRC; }
<PRE>SEM	{ yylval.v_keyword = SEM;  BEGIN(PARAM); return SEM;  }
<PRE>UNIT	{ yylval.v_keyword = UNIT; BEGIN(PARAM); return UNIT; }
<PRE>COPY	{ yylval.v_keyword = COPY; BEGIN(PARAM); return COPY; }
<PRE>CASS	{ yylval.v_keyword = CASS; BEGIN(PARAM); return CASS; }
<PRE>STAK	{ yylval.v_keyword = STAK; BEGIN(PARAM); return STAK; }
<PRE>SSTK	{ yylval.v_keyword = SSTK; BEGIN(PARAM); return SSTK; }
<PRE>CSTK	{ yylval.v_keyword = CSTK; BEGIN(PARAM); return CSTK; }
<PRE>RES	{ yylval.v_keyword = RES;  BEGIN(PARAM); return RES;  }
<PRE>STAT	{ yylval.v_keyword = STAT; BEGIN(PARAM); return STAT; }
<PRE>FRPO	{ yylval.v_keyword = FRPO; BEGIN(PARAM); return FRPO; }
<PRE>SPSZ	{ yylval.v_keyword = SPSZ; BEGIN(PARAM); return SPSZ; }
<PRE>PAGE	{ yylval.v_keyword = PAGE; BEGIN(PARAM); return PAGE; }
<PRE>TEXT	{ yylval.v_keyword = TEXT; BEGIN(PARAM); return TEXT; }
<PRE>RTXT	{ yylval.v_keyword = RTXT; BEGIN(PARAM); return RTXT; }
<PRE>CTXT	{ yylval.v_keyword = CTXT; BEGIN(PARAM); return CTXT; }
<PRE>STM	{ yylval.v_keyword = STM;  BEGIN(PARAM); return STM;  }
<PRE>SLM	{ yylval.v_keyword = SLM;  BEGIN(PARAM); return SLM;  }
<PRE>SRM	{ yylval.v_keyword = SRM;  BEGIN(PARAM); return SRM;  }
<PRE>SPW	{ yylval.v_keyword = SPW;  BEGIN(PARAM); return SPW;  }
<PRE>SBM	{ yylval.v_keyword = SBM;  BEGIN(PARAM); return SBM;  }
<PRE>SPL	{ yylval.v_keyword = SPL;  BEGIN(PARAM); return SPL;  }
<PRE>SLPP	{ yylval.v_keyword = SLPP; BEGIN(PARAM); return SLPP; }
<PRE>SPO	{ yylval.v_keyword = SPO;  BEGIN(PARAM); return SPO;  }
<PRE>SLS	{ yylval.v_keyword = SLS;  BEGIN(PARAM); return SLS;  }
<PRE>SLPI	{ yylval.v_keyword = SLPI; BEGIN(PARAM); return SLPI; }
<PRE>SCS	{ yylval.v_keyword = SCS;  BEGIN(PARAM); return SCS;  }
<PRE>SCPI	{ yylval.v_keyword = SCPI; BEGIN(PARAM); return SCPI; }
<PRE>SULP	{ yylval.v_keyword = SULP; BEGIN(PARAM); return SULP; }
<PRE>FONT	{ yylval.v_keyword = FONT; BEGIN(PARAM); return FONT; }
<PRE>ALTF	{ yylval.v_keyword = ALTF; BEGIN(PARAM); return ALTF; }
<PRE>SETF	{ yylval.v_keyword = SETF; BEGIN(PARAM); return SETF; }
<PRE>SCF	{ yylval.v_keyword = SCF;  BEGIN(PARAM); return SCF;  }
<PRE>RPF	{ yylval.v_keyword = RPF;  BEGIN(PARAM); return RPF;  }
<PRE>FLST	{ yylval.v_keyword = FLST; BEGIN(PARAM); return FLST; }
<PRE>FTMD	{ yylval.v_keyword = FTMD; BEGIN(PARAM); return FTMD; }
<PRE>SFA	{ yylval.v_keyword = SFA;  BEGIN(PARAM); return SFA;  }
<PRE>INTL	{ yylval.v_keyword = INTL; BEGIN(PARAM); return INTL; }
<PRE>GENF	{ yylval.v_keyword = GENF; BEGIN(PARAM); return GENF; }
<PRE>DELF	{ yylval.v_keyword = DELF; BEGIN(PARAM); return DELF; }
<PRE>DAF	{ yylval.v_keyword = DAF;  BEGIN(PARAM); return DAF;  }
<PRE>MAP	{ yylval.v_keyword = MAP;  BEGIN(PARAM); return MAP;  }
<PRE>MZP	{ yylval.v_keyword = MZP;  BEGIN(PARAM); return MZP;  }
<PRE>MRP	{ yylval.v_keyword = MRP;  BEGIN(PARAM); return MRP;  }
<PRE>MRPA	{ yylval.v_keyword = MRPA; BEGIN(PARAM); return MRPA; }
<PRE>SCP	{ yylval.v_keyword = SCP;  BEGIN(PARAM); return SCP;  }
<PRE>RPP	{ yylval.v_keyword = RPP;  BEGIN(PARAM); return RPP;  }
<PRE>SPD	{ yylval.v_keyword = SPD;  BEGIN(PARAM); return SPD;  }
<PRE>DAP	{ yylval.v_keyword = DAP;  BEGIN(PARAM); return DAP;  }
<PRE>DZP	{ yylval.v_keyword = DZP;  BEGIN(PARAM); return DZP;  }
<PRE>DRP	{ yylval.v_keyword = DRP;  BEGIN(PARAM); return DRP;  }
<PRE>DRPA	{ yylval.v_keyword = DRPA; BEGIN(PARAM); return DRPA; }
<PRE>BOX	{ yylval.v_keyword = BOX;  BEGIN(PARAM); return BOX;  }
<PRE>CIR	{ yylval.v_keyword = CIR;  BEGIN(PARAM); return CIR;  }
<PRE>PIE	{ yylval.v_keyword = PIE;  BEGIN(PARAM); return PIE;  }
<PRE>FPAT	{ yylval.v_keyword = FPAT; BEGIN(PARAM); return FPAT; }
<PRE>BLK	{ yylval.v_keyword = BLK;  BEGIN(PARAM); return BLK;  }
<PRE>ARC	{ yylval.v_keyword = ARC;  BEGIN(PARAM); return ARC;  }
<PRE>STR	{ yylval.v_keyword = STR;  BEGIN(PARAM); return STR;  }
<PRE>BARC	{ yylval.v_keyword = BARC; BEGIN(PARAM); return BARC; }
<PRE>CALL	{ yylval.v_keyword = CALL; BEGIN(PARAM); return CALL; }
<PRE>DELM	{ yylval.v_keyword = DELM; BEGIN(PARAM); return DELM; }
<PRE>DAM	{ yylval.v_keyword = DAM;  BEGIN(PARAM); return DAM;  }
<PRE>RDMP	{ yylval.v_keyword = RDMP; BEGIN(PARAM); return RDMP; }
<PRE>ENDD	{ yylval.v_keyword = ENDD; BEGIN(PARAM); return ENDD; }
<PRE>PAT	{ yylval.v_keyword = PAT;  BEGIN(PARAM); return PAT;  }
<PRE>SRO	{ yylval.v_keyword = SRO;  BEGIN(PARAM); return SRO;  }
<PRE>SFNT	{ yylval.v_keyword = SFNT; BEGIN(PARAM); return SFNT; }
<PRE>FSET       { yylval.v_keyword = FSET; BEGIN(PARAM); return FSET; }
<PARAM>\"[^\"]*\" {
  strcpy (yylval.v_string, yytext+1);
  yylval.v_string[strlen(yylval.v_string)-1] = '\0';
  return STRING;
}
<PARAM>\'[^\']*\' {
  strcpy (yylval.v_string, yytext+1);
  yylval.v_string[strlen(yylval.v_string)-1] = '\0';
  return STRING;
}
<PARAM>[A-Za-z0-9_]*[A-Za-z_][A-Za-z0-9_]* {
  strcpy (yylval.v_string, yytext);
  return OPTIONS;
}
<PARAM>;	{ BEGIN(PRE); return yytext[0]; }
<*>[ \t\f]+	{ if (retws) return WS; }
<*>\r?\n	{ lineno++; if (retws) return yytext[0]; }
<*>.		return yytext[0];
<<EOF>>		{
  if (inputfiles[++inputfile]) {
    if (inputfiles[inputfile][0]!='-' || inputfiles[inputfile][1]!='\0') {
      if ((yyin = fopen (inputfiles[inputfile], "r")) == NULL) {
	fprintf (stderr, "error: cannot open %s\n", inputfiles[inputfile]);
	exit (1);
      }
    }
    else {
      yyin = stdin;
    }
  }
  else {
    yyterminate();
  }
}
